;========================================================
;===             "THE IMPOSSIBLE PLANET"              ===
;===						      ===
;===	 	  (c) Luca Pavan - 1997	  	      ===
;===						      ===
;===		    Revised July 2013		      ===
;===		     Stereo version		      ===
;===	           				      ===
;===	             Duration: 7'57"		      ===
;========================================================

sr = 96000
kr = 96000
ksmps  = 1
nchnls = 2

#define E(A) #

ad1 init 0
ad3 init 0
ad5 init 0
ad7 init 0
ad9 init 0

ig=.01
as1 butbp a1,40,80
ad1 delay as1+ig*(ad1-ig*as1),.01
as2 butbp a1,200,240
as3 butbp a1,800,960
ad3 delay as3+ig*(ad3-ig*as3),.01
as4 butbp a1,3200,3840
as5 butbp a1,12800,15360
ad5 delay as5+ig*(ad5-ig*as5),.01
as6 butbp a2,50,60
as7 butbp a2,200,240
ad7 delay as7+ig*(ad7-ig*as7),.01
as8 butbp a2,800,960
as9 butbp a2,3200,3840
ad9 delay as9+ig*(ad9-ig*as9),.01
asa butbp a2,12800,15360
ao1=(ad1+as2+ad3+as4+ad5)*1.3
ao2=(as6+ad7+as8+ad9+asa)*1.3
al =(a1*(1-$A.))+(ao1*$A.)
ar =(a2*(1-$A.))+(ao2*$A.) #

garvbsig1 init 0
garvbsig2 init 0

instr 1
   
   idur      = p3
   iamp      = p4
   iskiptime = p5
   iattack   = p6
   irelease  = p7
   ifcmin    = p8     
   ifcmax    = p9
   kband     = p10
   kpan1     = p11
   kpan2     = p12
   icircles  = p13
   itime     = p14
   ipitch    = p15
   ifunc     = p16
                                      
   kamp		linen  iamp*.8, iattack, idur, irelease
   kpan1        poscil kpan1, (1/p3) * icircles, 6
   kpan2        poscil kpan2, (1/p3) * icircles, 5
   ktime        poscil itime, 1/p3, ifunc
   kpitch       poscil ipitch, 1/p3, ifunc
   
   asig         sndwarp 1, ktime, kpitch, 1, 0, 800, 400, 1, 9, 0
   arampsig1 =  kamp * asig
   
   if p17 = 0 goto nofilt
   asig         reson arampsig1, 1214.4, 20
   asig2        reson arampsig1, 1760, 20
   asig3        reson arampsig1, 2376, 20
   asig4        reson arampsig1, 3929.2, 20
   asig5        reson arampsig1, 5869.6, 20
   asig6        reson arampsig1, 8201.6, 20
   asig7        reson arampsig1, 14022.8, 20
   if p17 = 1 goto cont1
   nofilt: arampsig = arampsig1
   goto cont
   cont1: arampsig2 =  asig + asig2 + asig3 + asig4 + asig5 + asig6 + asig7
          arampsig     balance arampsig2, arampsig1
   cont: kcentro poscil   ifcmax, (1/p3) * icircles, 7
   autfilt1      butterbp arampsig * kpan1,ifcmin + kcentro, kband
   autfilt2      butterbp arampsig * kpan2,ifcmin + kcentro, kband
   krevhdif1     poscil  .5, (1/p3) * icircles, 8
   krevhdif2     poscil  .5, (1/p3) * icircles, 8
   arev1         reverb2  autfilt1, 3, .5+ krevhdif1
   arev2         reverb2  autfilt2, 3, .5+ krevhdif2
   a1    =    autfilt1 + arev1 * .2
   a2    =    autfilt2 + arev2 * .3
   $E(1)
      outs al, ar

   garvbsig1 =  garvbsig1 + a1 * .2
   garvbsig2 =  garvbsig2 + a2 * .3
        endin

   instr 99
   asig1a       reverb   garvbsig1, 3
   asig2a       reverb   garvbsig2, 2.5
   a1           butterhp asig1a, 65
   a2           butterhp asig2a, 65
   $E(1)
      outs al, ar
   garvbsig1 = 0
   garvbsig2 = 0
       endin